<script setup lang="ts">
import { useMemberStore } from '@/stores/member';
import type { Member } from '@/types/Member';
import { ref } from 'vue';
import type { VForm } from 'vuetify/components';
const textValidate = ref('')
const refform = ref<VForm | null>(null)
const memberStore = useMemberStore()

function OnInput() {
  memberStore.editedMember.tel = memberStore.editedMember.tel.replace(/[^0-9]/g, '')
}
async function save(){
    let { valid } = await refform.value!.validate()
    for (let index = 0; index < memberStore.members.length; index++) {
    const just: Member = memberStore.members[index]
    if(memberStore.editedMember.id === just.id){
        continue
    }
    if (memberStore.editedMember.tel === just.tel) {
        valid=false;
        textValidate.value = 'This number has already been used.'
    }
  }
  if (!valid) return
  console.log('just do it');
  memberStore.addMember()
}

</script>
<template>
    <v-dialog v-model="memberStore.dialog" persistent width="400">
    <v-card>
      <v-card-title>
        <span class="text-h5">Add Member</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="memberStore.form">
          <v-container>
            <v-row>
              <v-col cols="12" md="12" style="padding: 0;">
                <v-text-field v-model="memberStore.editedMember.name" :rules="[(v) => !!v || 'Please enter name.']" clearable
                  label="Name" placeholder="Enter your name"></v-text-field>
              </v-col>
              <v-col cols="12" md="12" style="padding: 0;">
                <v-text-field v-model="memberStore.editedMember.tel"
                  :rules="[(v) => !!v || 'Please enter phone number.', (v) => (v && v.length === 10) || 'Please provide all 10 digits.']"
                  clearable label="Tel" placeholder="Enter your tel" inputmode="numeric" pattern="[0-9]*"
                  @input="OnInput" @keyup.enter="save()"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
          <small>{{ textValidate }}</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="memberStore.dialog = false">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()">
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>